package org.dromara.zhishu.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.zhishu.domain.bo.RunningLogFileBo;
import org.dromara.zhishu.domain.vo.RunningLogFileVo;
import org.dromara.zhishu.domain.RunningLogFile;
import org.dromara.zhishu.mapper.RunningLogFileMapper;
import org.dromara.zhishu.service.IRunningLogFileService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 程序运行日志表Service业务层处理
 *
 * @author yxy
 * @date 2025-06-12
 */
@RequiredArgsConstructor
@Service
public class RunningLogFileServiceImpl implements IRunningLogFileService {

    private final RunningLogFileMapper baseMapper;

    /**
     * 查询程序运行日志表
     *
     * @param id 主键
     * @return 程序运行日志表
     */
    @Override
    public RunningLogFileVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    @Override
    public String selectMaxFileOrderByFileTypeAndCreateBy(String fileType,String userId){
        return baseMapper.selectMaxFileOrderByFileTypeAndCreateBy(fileType,userId);
    }

    /**
     * 分页查询程序运行日志表列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 程序运行日志表分页列表
     */
    @Override
    public TableDataInfo<RunningLogFileVo> queryPageList(RunningLogFileBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<RunningLogFile> lqw = buildQueryWrapper(bo);
        Page<RunningLogFileVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的程序运行日志表列表
     *
     * @param bo 查询条件
     * @return 程序运行日志表列表
     */
    @Override
    public List<RunningLogFileVo> queryList(RunningLogFileBo bo) {
        LambdaQueryWrapper<RunningLogFile> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<RunningLogFile> buildQueryWrapper(RunningLogFileBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<RunningLogFile> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(RunningLogFile::getId);
        lqw.like(StringUtils.isNotBlank(bo.getFileName()), RunningLogFile::getFileName, bo.getFileName());
        lqw.eq(StringUtils.isNotBlank(bo.getFileOrder()), RunningLogFile::getFileOrder, bo.getFileOrder());
        lqw.eq(StringUtils.isNotBlank(bo.getFileType()), RunningLogFile::getFileType, bo.getFileType());
        lqw.eq(StringUtils.isNotBlank(bo.getFileSize()), RunningLogFile::getFileSize, bo.getFileSize());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), RunningLogFile::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增程序运行日志表
     *
     * @param bo 程序运行日志表
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(RunningLogFileBo bo) {
        RunningLogFile add = MapstructUtils.convert(bo, RunningLogFile.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改程序运行日志表
     *
     * @param bo 程序运行日志表
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(RunningLogFileBo bo) {
        RunningLogFile update = MapstructUtils.convert(bo, RunningLogFile.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(RunningLogFile entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除程序运行日志表信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
